
package xelfi.awt;

import xelfi.util.Debug;

/**
 * Interface for objects which want to serve as 
 * the drag-drop operation informators.
	Last change:  DF   16 Mar 97    4:18 pm
*/
public interface XelfiDragDropInfo {

	/**
	 * Returns the source of the drag-drop operation
	 * (item that's being drag-dropped)
	*/
	public Object getSource ();

	/**
	 * Returns the destination of the drag-drop operation
   * (the container which receives dropped item)
	*/
  public Object getDestination ();

  /**
   * Returns the item after which is dropped source placed
   * in the dest container
  */
  public Object getPreviousItem ();

}
