package xelfi.awt;

/**
 * Any object that wants to own scrollable object
 * should implement this. Through this interface one 
 * can be notified about changing of visible area in 
 * scrollable object.
 *
 * @version 1.00, 1 Feb 1997
 * @author Dafe
	Last change:  DF    3 Feb 97   11:01 am
*/
public interface XelfiScrollableOwner {

	/**
	 * Notifies that visible area was changed.
	*/
	public void visibleAreaChanged ();

	/**
	 * Notifies that whole size of scrollable object
	 * was changed (due to inserting, deleting, for example).
	*/
	public void wholeSizeChanged ();

}

