
package xelfi.browser.document;

public class Modifiers
{
    private static final int finalM         = 256;
    private static final int staticM        = 128;
    private static final int nativeM        = 64;
    private static final int synchronizedM  = 32;
    private static final int abstractM      = 16;
    private static final int threadsafeM    = 8;
    private static final int transientM     = 4;

    private static final int access         = 3;
    private static final int privateM       = 3;
    private static final int protectedM     = 2;
    private static final int publicM        = 0;
    private static final int packageM       = 1;
    private int modifiers = packageM;

    public Modifiers()
    {
        modifiers = packageM;
    }
    public Modifiers(int modif)
    {
        modifiers = modif;
    }
    int getInt()
    {
        return modifiers;
    }
    public void reset()
    {
        modifiers = packageM;
    }
    public void setPublic()
    {
        modifiers = (modifiers & ~access) + publicM;
    }
    public void setPrivate()
    {
        modifiers = (modifiers & ~access) + privateM;
    }
    public void setProtected()
    {
        modifiers = (modifiers & ~access) + protectedM;
    }
    public void setFinal()
    {
        modifiers = modifiers | finalM;
    }
    public void setStatic()
    {
        modifiers = modifiers | staticM;
    }
    public void setNative()
    {
        modifiers = modifiers | nativeM;
    }
    public void setSynchronized()
    {
        modifiers = modifiers | synchronizedM;
    }
    public void setAbstract()
    {
        modifiers = modifiers | abstractM;
    }
    public void setThreadsafe()
    {
        modifiers = modifiers | threadsafeM;
    }
    public void setTransient()
    {
        modifiers = modifiers | transientM;
    }
    public boolean publicM()
    {
        return (access() == publicM);
    }
    public boolean privateM()
    {
        return (access() == privateM);
    }
    public boolean protectedM()
    {
        return (access() == protectedM);
    }
    public boolean finalM()
    {
        return (modifiers & finalM) != 0;
    }
    public boolean staticM()
    {
        return (modifiers & staticM) != 0;
    }
    public boolean nativeM()
    {
        return (modifiers & nativeM) != 0;
    }
    public boolean synchronizedM()
    {
        return (modifiers & synchronizedM) != 0;
    }
    public boolean abstractM()
    {
        return (modifiers & abstractM) != 0;
    }
    public boolean threadsafeM()
    {
        return (modifiers & threadsafeM) != 0;
    }
    public boolean transientM()
    {
        return (modifiers & transientM) != 0;
    }
    public int access()
    {
        return modifiers & access;
    }
}

