
package xelfi.browser.view;

import java.awt.*;
import java.io.*;
import java.util.*;
import xelfi.browser.document.*;
import xelfi.browser.util.*;
//import xelfi.util.*;
import xelfi.awt.PageControl;

public class BrowserSettingsPanel extends Panel
{
    Choice choObjSort;
    private BrSettings settings;

    static String[] SMode = staticInit();

    PageControl pc;
    Checkbox chPackProject;
    Checkbox chPackSystem;
    Checkbox chObjClass;
    Checkbox chObjInterface;
    Checkbox chObjModif;
    Checkbox chMemVariable;
    Checkbox chMemMethod;
    Checkbox chMemModif,chMemType,chMemInit;
    Checkbox chProjectOnly;
    TextField tfMemIndent;

    Choice choHierarched;
    Choice choColumns;
    Choice choMode,choMemSort;
    Checkbox chSort;
    Checkbox chMultipleSelectioned;
    Checkbox chDialog;
    Checkbox chChoice;
    Checkbox chCheckbox;

    Choice choApply;
    Button bApply;
    //Button bOk;
    //Button bCancel;

    static String[] staticInit()
    {
        String[] SMode = new String[5];
        SMode[0] = new String("Users:");
        SMode[1] = new String("Projects:");
        SMode[2] = new String("Packages:");
        SMode[3] = new String("Objects:");
        SMode[4] = new String("Members:");
        return SMode;
    }
    private void saveSettings()
    {
        // Global
        settings.Columns       = choColumns.getSelectedIndex()+1;
        settings.Mode          = choMode.getSelectedIndex();
        settings.MultipleSelectioned   = chMultipleSelectioned.getState();
        settings.Dialog        = chDialog.getState();
        settings.Choice        = chChoice.getState();
        settings.Checkbox      = chCheckbox.getState();

        // Members
        settings.MemVariable   = chMemVariable.getState();
        settings.MemMethod     = chMemMethod.getState();
        settings.MemShowModif  = chMemModif.getState();
        settings.MemShowType   = chMemType.getState();
        settings.MemShowInit   = chMemInit.getState();
        settings.MemIndent     = (new Integer(tfMemIndent.getText()))
                                    .intValue();
        settings.MemSort       = choMemSort.getSelectedIndex();
                                    // 0 - no 1 - abc 2 - abc +
                                    // vse v jednom

        // Objects
        settings.ObjClass      = chObjClass.getState();
        settings.ObjInterface  = chObjInterface.getState();
        settings.ObjPrjOnly    = chProjectOnly.getState();
        settings.ObjShowModif  = chObjModif.getState();;
        settings.ObjSort       = choObjSort.getSelectedIndex();
                                    // 0 - no 1 - abecedni
                                    // 2 - extends 3 - implem.

        // Packages
        settings.PackProject   = chPackProject.getState();
        settings.PackSystem    = chPackSystem.getState();

    }
    private void setSettings()
    {
        // Global
        choColumns.select(settings.Columns-1);
        choMode.select(settings.Mode);
        chMultipleSelectioned.setState(settings.MultipleSelectioned);
        chDialog.setState(settings.Dialog);
        chChoice.setState(settings.Choice);
        chCheckbox.setState(settings.Checkbox);

        // Members
        chMemVariable.setState(settings.MemVariable);
        chMemMethod.setState(settings.MemMethod);
        chMemModif.setState(settings.MemShowModif);
        chMemType.setState(settings.MemShowType);
        chMemInit.setState(settings.MemShowInit);
        tfMemIndent.setText("" + settings.MemIndent);
        choMemSort.select(settings.MemSort);
                                    // 0 - no 1 - abc 2 - abc +
                                    // vse v jednom

        // Objects
        chObjClass.setState(settings.ObjClass);
        chObjInterface.setState(settings.ObjInterface);
        chProjectOnly.setState(settings.ObjPrjOnly);
        chObjModif.setState(settings.ObjShowModif);;
        choObjSort.select(settings.ObjSort);
                                    // 0 - no 1 - abecedni
                                    // 2 - extends 3 - implem.

        // Packages
        chPackProject.setState(settings.PackProject);
        chPackSystem.setState(settings.PackSystem);

    }
    public BrowserSettingsPanel(BrWindow w)
    {
        //System.out.println("BSP "+ w);
        int select = 0;

        if( w == null )
            settings = new BrSettings(BrowserSettings.settings);
        else
        {
            int i,k = BrowserSettings.getBWNumber();
            for(i=0;i<k;i++)
                if( ((BrWindow)BrowserSettings.getBW(i)) == w )
                    break;
            if( i == k )
            {
                System.out.println("BrowserSettings error 129");
                return;
            }
            settings = ((BrowserPanel)(BrowserSettings.getBW(i).
                getComponent(0))).getSettings();
            select = ++i;
        }
        /*setLayout(new HorizLayout(HorizLayout.RESIZE,
            HorizLayout.CENTER));*/
        setLayout(new BorderLayout());

        // PAGE CONTROL
        pc = new PageControl();
        Panel panel,p;
        Label l;


        // MAIN SETTINGS
        panel = new Panel();
        panel.setLayout(new GridLayout(4,2));

        chPackProject = new Checkbox("Project packages");
        chPackProject.setState(settings.PackProject);
        panel.add(chPackProject);

        p = new Panel();
        p.setLayout(new DLayout());
        l = new Label("Columns:");
        p.add(l);

        choColumns = new Choice();
        choColumns.addItem("1");
        choColumns.addItem("2");
        choColumns.addItem("3");
        choColumns.select(settings.Columns-1);
        p.add(choColumns);
        panel.add(p);

        chPackSystem = new Checkbox("System packages");
        chPackSystem.setState(settings.PackSystem);
        panel.add(chPackSystem);

        p = new Panel();
        p.setLayout(new DLayout());
        l = new Label("Mode:");
        p.add(l);
        choMode = new Choice();
        for(int i=0;i<5;i++)
          choMode.addItem(SMode[i]);
        choMode.select(settings.Mode);
        p.add(choMode);
        panel.add(p);

        chMultipleSelectioned = new Checkbox("Multiple selections");
        chMultipleSelectioned.setState(settings.MultipleSelectioned);
        panel.add(chMultipleSelectioned);

        chChoice = new Checkbox("Show mode choice");
        chChoice.setState(settings.Choice);
        panel.add(chChoice);

        chDialog = new Checkbox("Browser is dialog");
        chDialog.setState(settings.Dialog);
        panel.add(chDialog);

        chCheckbox = new Checkbox("Show checkboxes");
        chCheckbox.setState(settings.Checkbox);
        panel.add(chCheckbox);

        //System.out.println("BSP 35");
        pc.addPage("Main",panel);
        //System.out.println("BSP 34");


        // OBJECTS
        panel = new Panel();
        panel.setLayout(new HorizLayout(HorizLayout.RESIZE,
            HorizLayout.CENTER));

        chObjClass = new Checkbox("Classes");
        chObjClass.setState(settings.ObjClass);
        panel.add(chObjClass);

        chObjInterface = new Checkbox("Interfaces");
        chObjInterface.setState(settings.ObjInterface);
        panel.add(chObjInterface);

        chProjectOnly = new Checkbox("Project objects only");
        chProjectOnly.setState(settings.ObjPrjOnly);
        panel.add(chProjectOnly);

        chObjModif = new Checkbox("Show modifiers");
        chObjModif.setState(settings.ObjShowModif);
        panel.add(chObjModif);

        p = new Panel();
        p.setLayout(new DLayout());
        l = new Label("Ordering:");
        p.add(l);
        choObjSort = new Choice();
        choObjSort.addItem("None");
        choObjSort.addItem("Sorted");
        choObjSort.addItem("Extends");
        choObjSort.addItem("Implements");
        choObjSort.select(settings.ObjSort);
        p.add(choObjSort);
        panel.add(p);

        pc.addPage("Objects",panel);


        // MEMBERS
        panel = new Panel();
        panel.setLayout(new HorizLayout(HorizLayout.RESIZE,
            HorizLayout.CENTER));

        chMemMethod = new Checkbox("Methods");
        chMemMethod.setState(settings.MemMethod);
        panel.add(chMemMethod);

        chMemVariable = new Checkbox("Variables");
        chMemVariable.setState(settings.MemVariable);
        panel.add(chMemVariable);

        chMemModif = new Checkbox("Show modifiers");
        chMemModif.setState(settings.MemShowModif);
        panel.add(chMemModif);

        chMemType = new Checkbox("Show type");
        chMemType.setState(settings.MemShowType);
        panel.add(chMemType);

        chMemInit = new Checkbox("Show init. value");
        chMemInit.setState(settings.MemShowInit);
        panel.add(chMemInit);

        p = new Panel();
        p.setLayout(new DLayout());
        l = new Label("Name indent:");
        p.add(l);
        tfMemIndent = new TextField("" + settings.MemIndent);
        p.add(tfMemIndent);
        panel.add(p);

        p = new Panel();
        p.setLayout(new DLayout());
        l = new Label("Sorting:");
        p.add(l);
        choMemSort = new Choice();
        choMemSort.addItem("None");
        choMemSort.addItem("In objects");
        choMemSort.addItem("Whole selection");
        choMemSort.select(settings.MemSort);
        p.add(choMemSort);
        panel.add(p);

        pc.addPage("Members",panel);

        // Main
        add("Center",pc);

        panel = new Panel();
        add("South",panel);

        panel.setLayout(new FlowLayout(FlowLayout.CENTER));

        bApply = new Button("Apply");
        panel.add(bApply);

        l = new Label(" changes to:");
        panel.add(l);

        choApply = new Choice();
        choApply.addItem("Next Browser window");
        int i,k = BrowserSettings.getBWNumber();

        for(i=0;i<k;i++)
            choApply.addItem(BrowserSettings.getBWTitle(i));
        panel.add(choApply);

        choApply.select(select);

        /*pp = new Panel();
        add(pp);

        pp.setLayout(new FlowLayout(FlowLayout.CENTER));
        bApply = new Button("Apply");
        pp.add(bApply);

        bOk = new Button("Ok");
        pp.add(bOk);

        bCancel = new Button("Cancel");
        pp.add(bCancel);*/


        //System.out.println("BSP END");
    }
    public void onOk()
    {
        onApply();
    }
    public void setPage(int i)
    {
        pc.setTabIndex(i);
    }
    public boolean action(Event e, Object arg)
    {
        if( e.target == bApply )
        {
            onApply();
            return true;
        }else
        if( e.target == choApply )
        {
            int i = choApply.getSelectedIndex();
            if( i == 0 )
            {
                settings = BrowserSettings.settings;
                setSettings();
            }else
            if( i > 0 )
            {
                settings = BrowserSettings.getBPanel(i-1).getSettings();
                setSettings();
            }
            return true;
        }
        return false;
    }
    private void onApply()
    {
        saveSettings();
        int i = choApply.getSelectedIndex();
        if( i == 0 )
        {
            BrowserSettings.settings = settings;
        }else
        if( i > 0 )
        {
            BrowserSettings.ChangePanel(BrowserSettings.getBW
                (i - 1),settings);
        }
        return;
    }
 }






