/** XelfiCompilerMain class
* @author: Filip Dvorak
* @version: 1.3
*/

package xelfi.compiler;

import sun.tools.javac.*;
import sun.tools.java.*;
import java.io.*;


class XelfiCompilerMain extends Main implements MainCompiler
{
    /** Output from compiler is send here. */
  protected XelfiCompilerOutput out;

  XelfiCompilerMain(XelfiCompilerOutput o)
  {
    super(o, "javac");
    out = o;
  }

  public void compileClass(File file)
  {
    String args[] = null;
    if(CompilerOptions.getUseGparam())
    {
      args = new String[2];
      args[0] = "-g";
      args[1] = file.toString();
      output("Compiling: " + args[0] + " " + args[1]);
    }
    else
    {
      args = new String[1];
      args[0] = file.toString();
      output("Compiling: " + args[0]);
    }
    compile(args);
    output("\n");
  }

  public void error(String err)
  {
    out.topLevelError(err);
  }

  public void output(String msg)
  {
    out.topLevelOutput(msg);
  }
}
