/**
* Xelfi
*/

package xelfi.design.components.property;

import java.io.*;
import java.awt.Font;
import java.awt.Frame;
import xelfi.design.components.XelfiDesignComponent;
import xelfi.design.components.dialogs.FontSelectThread;
import xelfi.util.Debug;

/**
 * @version 	1.40, 08 Feb 1997 (from version 1.30 persistence is added)
 * @author 	Ian Formanek
 */

public class XFontPropertyType {
	/**
	 * This method invokes the specialInput Dialog.
	 * To perform this under JDK 1.02, a new thread must be started to do this.
	 * This method returns immediately allowing the AWT thread to run (if called from within
	 * the action method or so...).
	 * The new thread starts the dialog and then waits in a loop for some variable to be set.
	 * Then if user pressed the OK Button method setProperty of the component is called.
	 * @param	parent	parent of the dialog
	 * @param	xdc		Component which property to set
	 * @param	propNum	Index of the property to set
	 */
	public static void invokeSpecialInput(Frame parent, XelfiDesignComponent xdc, int propNum) {
		new FontSelectThread("FontSelectThread", parent, xdc, propNum).start(); 
	}

	public static String viewString(Object property) { return "[Font]"; }

	public static void saveToStream(Object property, DataOutput stream) throws 
		IOException {
		stream.writeUTF(((Font)property).getName());
		stream.writeInt(((Font)property).getStyle());
		stream.writeInt(((Font)property).getSize());
		Debug.debug(Debug.PROPIO_SAVE, "XFontProperty saved");
	}

	public static Font loadFromStream(DataInput stream) throws 
		IOException {
		String name = stream.readUTF();
		int style = stream.readInt();
		int size = stream.readInt();
		Debug.debug(Debug.PROPIO_LOAD, "XFontProperty loaded: [name: "+name+", style: "+style+", size: "+size);
		return new Font(name,style,size);
	}
}
