/**
* Xelfi
*/

package xelfi.design.util;

import java.awt.*;
import java.awt.image.*;
import xelfi.top.TopLevel;
import xelfi.top.XelfiOptions;
import xelfi.util.EnhProperties;

/**
* @version		1.13, 25 Mar 97
*		from 1.11 implements XelfiOptions
* @author 		Ian Formanek
*/

public class XFDesignOptions implements XelfiOptions {
	
	//////////////////
	// XelfiOptions //
	//////////////////

  public void loadProperties(EnhProperties src) {
  };

  public void storeProperties(EnhProperties dest) {
  };

  public Panel getPanel() {
    return null;
  };

  public String getTabName() {
    return "FormEditor";
  };

  public void onOK(Panel p) {
  };

	////////////////
	// Persistent //
	////////////////

	// border size for awt controls that are dragged by this border
	public static int borderSize = 4;

	// how much points must a component be dragged from its original position (in either dir.) to really drag it
	public static int minDragSize = 3;

	// this should be in editor options
	public static String indent = "  ";
	public static String indent(int num) {
		String ind = "";
		for (int i=0; i<num; i++)
			ind += indent;
		return ind;
	}

	public static int formDefWidth = 400;	
	public static int formDefHeight = 200;	
	
	public static int selectionSize = 4;
	public static Color selectionColor = new Color(0,0,128);
	public static Color selectionSpecColor = new Color(255,0,0);
	public static Color draggingColor = new Color(128,128,128);

	public static String eventVarName = "evt";
	
	public static int importsThreshold = 3;

	public static Color GuardedBlockBackground = Color.darkGray;

	public static XelfiColor defaultFormBackground = new XelfiColor();
	
	////////////////////
	// Not persistent //
	////////////////////

	public static String USER_CLASSES_TEXT = "// Place for other classes:\n\n";
	public static String USER_METHODS_TEXT = "// Place for other methods/variables:\n\n";
	public static String USER_IMPORTS_TEXT = "// Here go your own imports:\n\n";
	public static String USER_CONSTRUCTOR_TEXT = indent(2)+"// Here goes your own init code:\n\n";
	
	// current mode (Design/Real)
	public static int designMode=XFDesignConstants.DM_DESIGN;

	// if components are locked then they can only be selected (not dragged/resized)
	public static boolean lockComponents = false;
	
	public static int gridX = 10;
	public static int gridY = 10;
	public static boolean showGrid = true;

}	