/**
* Xelfi Environment
*/

package xelfi.editor;

/** Called after insert or delete.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public interface ActionPostListener {
  /** Notifies that an insert has been done at position p.
  * @param n the begin of inserted text
  * @param p the end of inserted text
  */
  public void notifyInsert (Position n, Position p);

  /** Notifies a delete
  * @param p the position where a delete occures
  * @param s the string with characters that has been deleted
  */
  public void notifyDelete (Position p, String s);
}



// Generated from substitution template 'XelfiInterface' Blocks:Class:17,11,35,11; Package:8,4,20,4; 
