/**
* Xelfi programming environment
*/

package xelfi.editor;

import java.io.DataOutput;
import java.io.IOException;
/**
* Saves every position to specified stream.
*
* @version 1.0
* @author Jaroslav Tulach
*/

class Saver implements Acceptor {
  /** the stream to save to */
  private DataOutput stream;

  /** the exception to be raised */
  IOException exception = null;
  
  /** New saver.
  * @param s the stream to save to
  */
  public Saver (DataOutput s) {
    stream = s;
  }
  
  /**
  *
  * @param ch the character at specified position
  * @return false to continue the action, true is returned only when an error occures
  */
  public boolean accept (char ch) {
    try {
      stream.writeByte ((byte)ch);
      return false;
    } catch (IOException ex) {
      exception = ex;
      return true;
    }
  }
}


