/**
* Xelfi Environment
*/

package xelfi.editor.actions;
import xelfi.editor.*;
import xelfi.editor.keys.*;
import java.util.Vector;

/** Set block begin.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public class BlockBegin extends Object implements KeyActionHandler {
  /** Initialize the object.
  * @param v vector of parameters. It can contain objects of type
  *   String, Integer, Character.
  * @exception IllegalArgumentException if a parameter is not valid
  */
  public void init (Vector v) {
  };

  /** Inserts the key to the editor.
  * @param key the key code that occured
  * @param modifiers the state of modifiers
  * @param info info about editor
  * @return true if next command should be excecuted, false if
  *   the action should stop
  * @exception NotAllowedException if the action is not allowed
  */
  public boolean keyDown (int key, int modifiers, TextEditorInfo info)
  throws NotAllowedException {
    Block b = info.getSelectedBlock ();
    Position p = info.getCursorPos ();
    try {
      b = new Block (p, b.getEnd ());
    } catch (Exception ex) {
      // clear the block
      b = new Block (p, p);
    };
    info.setSelectedBlock (b);
    return true;
  };
}








