package xelfi.execution;

import java.awt.*;

import xelfi.top.visual.*;

class RunOptionsPanel extends Panel
{
  private TextField ipath, args, mainc, clearAfter, appw, apph;
  private Checkbox ch1, ch2, ch3, ch4;

  RunOptionsPanel()
  {
    super();

    RowLayout rl = new RowLayout();
    RowLayoutProperties rlp = new RowLayoutProperties();
    setLayout(rl);
      // Path panel
    Panel pathp = new Panel();
    rlp.compInsets = new Insets(4, 4, 8, 4);
    rlp.topSpaceGrowth = 0.04f;
    rlp.bottomSpaceGrowth = 0.26f;
    rlp.compGrowth = 0.30f;
    add(pathp);
    rl.add(pathp, rlp);
      // check boxes
    ch1 = new Checkbox("Show StdIO window when running a class");
    ch2 = new Checkbox("Stdout and Stderr separated");
    ch3 = new Checkbox("Show Stdin");
    ch4 = new Checkbox("Close when finished");
    add(ch1);
    add(ch2);
    add(ch3);
    add(ch4);
    rlp.compInsets = new Insets(2, 4, 2, 4);
    rlp.compGrowth = rlp.topSpaceGrowth = 0;
    rlp.bottomSpaceGrowth = 0.03f;
    rlp.rightSpaceGrowth = 0.99f;
    rl.add(ch1, rlp);
    rlp.compInsets = new Insets(2, 40, 2, 4);
    rl.add(ch2, rlp);
    rl.add(ch3, rlp);
    rl.add(ch4, rlp);
      // text buffer lines panel
    Panel tbpanel = new Panel();
    rlp.compInsets.bottom = 8;
    rlp.bottomSpaceGrowth = 0.10f;
    add(tbpanel);
    rl.add(tbpanel, rlp);
      // applet size panel
    Panel apanel = new Panel();
    rlp.compInsets.bottom = 14;
    rlp.compInsets.left = 4;
    rlp.bottomSpaceGrowth = 0.18f;
    add(apanel);
    rl.add(apanel, rlp);

          // path panel setup
    ColLayout pathpl = new ColLayout();
    ColLayoutProperties pathpp = new ColLayoutProperties(new Insets(0, 0, 0, 20));
    pathp.setLayout(pathpl);
    pathpp.rightSpaceGrowth = 0.08f;
        // left panel
    Panel pathlp = new Panel();
    pathp.add(pathlp);
    pathpl.add(pathlp, pathpp);
        // right panel
    pathpp.rightSpaceGrowth = 0;
    pathpp.compGrowth = 0.92f;
    pathpp.compInsets = new Insets(0, 0, 0, 0);
    Panel pathrp = new Panel();
    pathp.add(pathrp);
    pathpl.add(pathrp, pathpp);
      // left panel setup
    RowLayout pathlpl = new RowLayout();
    pathlp.setLayout(pathlpl);
    RowLayoutProperties pathlpp = new RowLayoutProperties(new Insets(0, 0, 16, 0));
    Label lab4 = new Label("Main class:");
    Label lab5 = new Label("Java interpreter path:");
    Label lab3 = new Label("Arguments:");
    pathlpp.bottomSpaceGrowth = 0.5f;
    pathlp.add(lab5);
    pathlp.add(lab3);
    pathlp.add(lab4);
    pathlpl.add(lab5, pathlpp);
    pathlpl.add(lab3, pathlpp);
    pathlpp.compInsets.bottom = 0;
    pathlpp.bottomSpaceGrowth = 0;
    pathlpl.add(lab4, pathlpp);
      // right panel setup
    RowLayout pathrpl = new RowLayout();
    pathrp.setLayout(pathrpl);
    RowLayoutProperties pathrpp = new RowLayoutProperties(new Insets(0, 0, 16, 0));
    pathrpp.bottomSpaceGrowth = 0.5f;
    ipath = new TextField(40);
    args = new TextField(25);
    mainc = new TextField(30);
    pathrp.add(ipath);
    pathrp.add(args);
    pathrp.add(mainc);
    pathrpl.add(ipath, pathrpp);
    pathrpl.add(args, pathrpp);
    pathrpp.compInsets.bottom = 0;
    pathrpp.bottomSpaceGrowth = 0;
    pathrpl.add(mainc, pathrpp);

      // buffer lines panel setup
    ColLayout tbpl = new ColLayout();
    ColLayoutProperties tbpp = new ColLayoutProperties(new Insets(0, 0, 0, 14));
    tbpanel.setLayout(tbpl);
    Label l2 = new Label("Clear output after");
    clearAfter = new TextField(5);
    tbpanel.add(l2);
    tbpanel.add(clearAfter);
    tbpl.add(l2, tbpp);
    tbpp.compGrowth = 1f;
    tbpp.compInsets = new Insets(0, 0, 0, 0);
    tbpl.add(clearAfter, tbpp);
    Label l1 = new Label("lines");
    tbpp.compGrowth = 0f;
    tbpp.compInsets = new Insets(0, 8, 0, 0);
    tbpanel.add(l1);
    tbpl.add(l1, tbpp);

    // applet size panel setup
    ColLayout apl = new ColLayout();
    ColLayoutProperties app = new ColLayoutProperties(new Insets(0, 0, 0, 0));
    apanel.setLayout(apl);
    Label l10 = new Label("Initial applet size   width = ");
    appw = new TextField(4);
    Label l11 = new Label("height = ");
    apph = new TextField(4);
    apanel.add(l10);
    apanel.add(appw);
    apanel.add(l11);
    apanel.add(apph);
    apl.add(l10, app);
    app.compInsets.right = 8;
    apl.add(appw, app);
    app.compInsets.right = 0;
    apl.add(l11, app);
    apl.add(apph, app);

    ch1.setState(RunOptions.showIOWindow());
    ch2.setState(!RunOptions.stdOutErrTogether());
    ch3.setState(RunOptions.showStdin());
    ch4.setState(RunOptions.closeWhenFinished());

    clearAfter.setText(new Integer(RunOptions.clearOutputAfter()).toString());
    ipath.setText(RunOptions.getInterpretPath());
    args.setText(RunOptions.getArguments());
    String tmp = RunOptions.getMainClass();
    mainc.setText(tmp == null ? "" : tmp);
    appw.setText(new Integer(RunOptions.getAppletWidth()).toString());
    apph.setText(new Integer(RunOptions.getAppletHeight()).toString());
  }

  void saveValues()
  {
    RunOptions.ipath = ipath.getText();
    RunOptions.args = args.getText();
    RunOptions.setMainClass(mainc.getText());

    RunOptions.showIO = ch1.getState();
    RunOptions.togetherOE = !ch2.getState();
    RunOptions.showIn = ch3.getState();
    RunOptions.close = ch4.getState();

    int lines;
    try
    {
      lines = Integer.valueOf(clearAfter.getText()).intValue();
    }
    catch(NumberFormatException ex) { lines = 2048; }
    if(lines < 0) lines = 0;
    if(lines > 65536) lines = 65536;
    RunOptions.clearOutAfter = lines;

    int aplw;
    try
    {
      aplw = Integer.valueOf(appw.getText()).intValue();
    }
    catch(NumberFormatException ex) { aplw = -1; }
    RunOptions.appletWidth = aplw;

    int aplh;
    try
    {
      aplh = Integer.valueOf(apph.getText()).intValue();
    }
    catch(NumberFormatException ex) { aplh = -1; }
    RunOptions.appletHeight = aplh;
  }

  public boolean keyDown(Event ev, int key)
  {
    if((ev.target == clearAfter || ev.target == appw || ev.target == apph) &&
      (((int)'a' <= key && key <= (int)'z') || ((int)'A' <= key && key <= (int)'Z')))
      return true;
    else return false;
  }
}














