/** Stream pipe  class

* @author: Filip Dvorak

* @version: 1.2

*/



package xelfi.execution;



import java.io.*;



public class StreamPipe implements Runnable

{

  InputStream in;

  OutputStream out;

  boolean reportEx;



  public StreamPipe(OutputStream dest, InputStream src)

  {

    this(dest, src, true);

  }



  public StreamPipe(OutputStream dest, InputStream src, boolean reportExceptions)

  {

    in = src;

    out = dest;

    reportEx = reportExceptions;

  }



  public void run()

  {

    int dataLen;

    byte b[] = new byte[128];



    try

    {

      while((dataLen = in.read(b)) != -1)

      {

        out.write(b, 0, dataLen);

        out.flush();  // we want the out to be bufferred the same way as is the in stream

      }

    }

    catch(IOException e)

    {

      try

      {

        if(reportEx) out.write(toByteArray(("Child process pipe exception: " + e + "\n").toCharArray()));

      }

      catch(IOException ex) {}

    }
    return;

  }



  public static byte[] toByteArray(char charray[])

  {

    byte barray[] = new byte[charray.length];

    for(int i = 0; i < charray.length; i++) barray[i] = (byte)charray[i];

    return barray;

  }

}



