/**
* Xelfi programming environment
*/

package xelfi.xedit;
import xelfi.editor.Block;
/**
* Info that is returned from Comments.find (Position).
*
* @version 1.0
* @author Jaroslav Tulach
*/

public class CommentInfo extends Object {
  /** Id for not yet assigned value */
  public static final byte UNKNOWN = 0x00;

  /** Id for empty text outside comments */
  public static final byte NOTHING = 0x01;

  /** Id for block comment */
  public static final byte BLOCK_COMMENT = 0x02;

  /** Id for line comment */
  public static final byte LINE_COMMENT = 0x03;

  /** Id for string */
  public static final byte STRING = 0x04;

  /** The comment's block. */
  public Block comment;

  /** Type of the comment. */
  public byte type;

  /** Forbids  creating of new instances.
  */
  private CommentInfo () {
    type = NOTHING;
  };

  /** Creates new info. Usable only in this
  * package.
  * @param b the block of comment
  * @param t the type of comment
  */
  CommentInfo (Block b, byte t) {
    comment = b;
    type = (byte)t;
  };
};









